unit Splash;
  (* See Tom Swan's Delphi 4 Bible, pages 110-115.  To use,
       1.  Add to project as NON-autocreated form.
       2.  Modify lbSplash & imgSplash as needed.
       3.  In DPR form, 
             RunOnlyOneInstance(xxx);
             fmSplash := tfmSplash.Create(Application);
             try
               fmSplash.Show;
               fmSplash.Update;
                 Application.Initialize;
               fmSplash.StatusUpdate('Creating data modules....');
                 Application.CreateForm(tdmAdvMaster, dmAdvMaster);
                 Application.CreateForm(tdmBoxes, dmBoxes);
               fmSplash.StatusUpdate('Creating autocreated forms....');
                 Application.CreateForm(tfmAddOrEditService, fmAddOrEditService)                       <CreateForm calls>
               fmSplash.Close
             finally
               fmSplash.Release
             end
         *)

  interface
    uses
      Classes,
      Controls,
      ExtCtrls (* tBevel, tImage *),
      Forms    (* Application, tForm *),
      Graphics,
      StdCtrls (* tLabel *),
      Windows  (* GetFileVersionInfo, GetFileVersionInfoSize, VerQueryValue;
                    also used by Forms *);

    type
      tfmSplash = class(tForm)
          bvSplash: tBevel;
          imgSplash: tImage;
          lbDate:   tLabel;
          lbEmail:  tLabel;
          lbRRF:    tLabel;
          lbSplash: tLabel;
          lbStatus: tLabel;
          lbVersion: TLabel;
    procedure FormShow(Sender: TObject);
        public
          procedure StatusUpdate(const S: string);
        end (* tfmSplash *);

    var
      fmSplash: tfmSplash;

  implementation
    uses
      CompileDate (* CompileDay, CompileMonth, CompileYear *),
      SysUtils (* AllocMem, Date, Format, Sleep, Trim *);
      {$R *.DFM}

    const
      OneSecond = 1000;

    function FileVersion: string;
      (* from http://delphi.about.com/cs/adptips2001/a/bltip0701_4.htm *)

      const
        ParameterIgnored = 0;
        FileVersionName = 'StringFileInfo\040904E4\FileVersion';

      var
        Buffer, Receiver: pChar;
        InfoSize: cardinal;
        ResultLength (* not used *): cardinal;
        ExeName: string;

      begin (* FileVersion *)
        Result := 'n/a';
        ExeName := Application.ExeName;
        InfoSize := GetFileVersionInfoSize(pChar(ExeName), InfoSize);

        if InfoSize > 0 then
          begin (* ask Windows for the info *)
            Buffer := AllocMem(InfoSize);
            try     (* must free buffer *)
              GetFileVersionInfo(pChar(ExeName),
                                 ParameterIgnored,
                                 InfoSize,
                                 Buffer);
              if VerQueryValue(Buffer,
                               pChar(FileVersionName),
                               pointer(Receiver),
                               ResultLength) then
                Result := Trim(Receiver)
            finally (* must free buffer *)
              FreeMem(Buffer, InfoSize)
            end     (* must free buffer *)
          end   (* ask Windows for the info *)
      end   (* FileVersion *);

    procedure tfmSplash.FormShow(Sender: tObject);
      (* show date & version *)

      begin (* tfmSplash.FormShow *)
        lbDate.Caption := Format('%d-%.2d-%.2d', [CompileYear, CompileMonth, CompileDay]);
        lbVersion.Caption := FileVersion
      end   (* tfmSplash.FormShow *);

    procedure tfmSplash.StatusUpdate(const S: string);
      (* Keep the user informed *)

      begin (* tfmSplash.StatusUpdate *)
        lbStatus.Caption := S;
        Update;
        Sleep(2 * OneSecond)
      end   (* tfmSplash.StatusUpdate *);

end.
